;###############################################################################
/* ExportGui for LilBuilder

*/
;###############################################################################

ExportGui_Create(){
  ;gui is created hidden
  ExportGui_LB_BuildGui()   ;build all guis with a single function call

  ;fill data into gui
  GuiControl, 4:, ExportGui_EdtFile, % Project("_LastSession")
  GuiControl, 4:, ExportGui_EdtPrefixFunc, % Project("ProjectName")
  GuiControl, 4:, ExportGui_ChkRunExport, % Project("RunExport")
  GuiControl, 4:, ExportGui_ChkExportOnlyData, % Project("ExportOnlyData")
  GuiControl, 4:, ExportGui_ChkExportOnlyDataAndFunc, % Project("ExportOnlyDataAndFunc")
  ExportGui_ChkExportOnlyData(4)
  ExportGui_ChkExportOnlyDataAndFunc(4)
  ExportGui_ChkExport(4)

  ;show gui
  Gui, 4:Show
}

ExportGui_BtnExport:
  ExportGui_BtnExport(A_Gui)
ExportGui_BtnCancel:
ExportGui_Close:
 Gui, 4:Destroy
Return

ExportGui_BtnExport(GuiID){
  GuiControlGet, OutFile , %GuiID%:,ExportGui_EdtFile
  If !OutFile
    Return

  GuiControlGet, ChkRealAHKScript , %GuiID%:,ExportGui_ChkRealAhkScript
  GuiControlGet, ChkRunExport , %GuiID%:,ExportGui_ChkRunExport
  GuiControlGet, ChkExportOnlyData , %GuiID%:,ExportGui_ChkExportOnlyData
  GuiControlGet, ChkExportOnlyDataAndFunc , %GuiID%:,ExportGui_ChkExportOnlyDataAndFunc

  GuiControlGet, ExportGui_ChkPrefixFunc , %GuiID%:,ExportGui_ChkPrefixFunc
  GuiControlGet, PreFix , %GuiID%:,ExportGui_EdtPrefixFunc

  If !ExportGui_ChkPrefixFunc
    PreFix =
  SaveLoad_ExportProject(OutFile, PreFix, ChkRealAHKScript, ChkRunExport, ChkExportOnlyData
                        , ChkExportOnlyDataAndFunc)
}

ExportGui_EdtFile:
  ExportGui_EdtFile(A_Gui)
Return
ExportGui_EdtFile(GuiID){
  GuiControlGet, OutFile , %GuiID%:,ExportGui_EdtFile
  Status := OutFile ? 1 : 0
  GuiControl, %GuiID%:Enable%Status%, ExportGui_BtnExport
}

ExportGui_ChkRealAhkScript:
ExportGui_ChkRunExport:
  ExportGui_ChkExport(A_Gui)
Return
ExportGui_ChkExport(GuiID){
  GuiControlGet, Status1 , %GuiID%:,ExportGui_ChkRunExport
  GuiControlGet, Status2 , %GuiID%:,ExportGui_ChkRealAhkScript
  Status := Status1 OR Status2
  If Status {
    GuiControl, %GuiID%:, ExportGui_ChkExportOnlyData, % !Status
    GuiControl, %GuiID%:, ExportGui_ChkExportOnlyDataAndFunc, % !Status
  }
  Status := !Status
  GuiControl, %GuiID%:Enable%Status%, ExportGui_ChkExportOnlyData
  GuiControl, %GuiID%:Enable%Status%, ExportGui_ChkExportOnlyDataAndFunc
}

ExportGui_ChkExportOnlyData:
  ExportGui_ChkExportOnlyData(A_Gui)
Return
ExportGui_ChkExportOnlyData(GuiID){
  GuiControlGet, Status , %GuiID%:,ExportGui_ChkExportOnlyData
  If Status
    GuiControl, %GuiID%:, ExportGui_ChkExportOnlyDataAndFunc, % !Status
  Status := !Status
  GuiControl, %GuiID%:Enable%Status%, ExportGui_ChkExportOnlyDataAndFunc
}

ExportGui_ChkExportOnlyDataAndFunc:
  ExportGui_ChkExportOnlyDataAndFunc(A_Gui)
Return
ExportGui_ChkExportOnlyDataAndFunc(GuiID){
  GuiControlGet, Status , %GuiID%:,ExportGui_ChkExportOnlyDataAndFunc
  If Status
    GuiControl, %GuiID%:, ExportGui_ChkExportOnlyData, % !Status
  Status := !Status
  GuiControl, %GuiID%:Enable%Status%, ExportGui_ChkExportOnlyData
}

ExportGui_ChkPrefixFunc:
  ExportGui_ChkPrefixFunc(A_Gui)
Return
ExportGui_ChkPrefixFunc(GuiID){
  GuiControlGet, Status , %GuiID%:,ExportGui_ChkPrefixFunc
  GuiControl, %GuiID%:Enable%Status%, ExportGui_EdtPrefixFunc
}

ExportGui_BtnBrowseFile:
  ExportGui_BtnBrowseFile()
Return
ExportGui_BtnBrowseFile(){
	FileSelectFile, OutFile, S16, GuiScript.ahk, Save Project as File, Any file (*)
	If OutFile
    GuiControl, 4:, ExportGui_EdtFile, %OutFile%
}

ExportGui_Size:
	ExportGui_LB_Anchor( "ExportGui_BtnBrowseFile", "x")
	ExportGui_LB_Anchor( "ExportGui_BtnExport", "x")
	ExportGui_LB_Anchor( "ExportGui_BtnCancel", "x")
	ExportGui_LB_Anchor( "ExportGui_EdtFile", "w")
	ExportGui_LB_Anchor( "ExportGui_EdtPrefixFunc", "w")
	ExportGui_LB_Anchor( "ExportGui_GrbOptions", "w")
Return
