;###############################################################################
/* CommonMenu for LilBuilder

*/
;###############################################################################

CommonMenu_AddCommonItems(Menu_ID, CtrlType){
  MMenu_Add(Menu_ID , "Set VarName","","","iCommonMenu_SetVarName")
  MMenu_Add(Menu_ID , "Set Label","","","iCommonMenu_SetLabel")
  MMenu_Add(Menu_ID , "Hidden","","","iCommonMenu_ToggleState")
  If (CtrlType != "StatusBar"){
    MMenu_Add(Menu_ID , "Disable","","","iCommonMenu_DisableControl")
    MMenu_Add(Menu_ID , "Anchor Control","","","iCommonMenu_AnchorControl")
  }
  If CtrlType in Button,CheckBox,ComboBox,DateTime,DropDownList,Edit,GroupBox,HotKey,ListBox,MonthCal,Progress,Radio,Slider,UpDown,Text,Picture,StatusBar
      MMenu_Add(Menu_ID , "Change Content","","","iCommonMenu_ChangeContent")
  MMenu_Add(Menu_ID , "Duplicate Control","","","iCommonMenu_Duplicate")
  MMenu_Add(Menu_ID)
}

CommonMenu_UpdateMenu(Menu_ID){
  CtrlHWND := Menu_vCtrlHWND()
  Type := Control(CtrlHWND, "Type")

  VarName := Control(CtrlHWND,"_FinalVarName")
  Text := VarName ? "Change VarName: " VarName : "Set VarName"
  MMenu_Set(Menu_ID,1, Text)

  Label := Control(CtrlHWND,"Label")
  Text := Label ? "Change Label: " Label : "Set Label"
  MMenu_Set(Menu_ID,2, Text)

  Toggles = Hidden
  Loop, Parse, Toggles , |
  {
    CheckStatus := Control(CtrlHWND,A_LoopField) ? "+c" : "-c"
    MMenu_Set(Menu_ID, A_Index + 2,"","",CheckStatus )
  }

  Disabled := Control(CtrlHWND,"Disabled")
  Text := Disabled ? "Enable" : "Disable"
  MMenu_Set(Menu_ID,4, Text)

  If (CtrlType != "StatusBar"){
    AnchorValue := Control(CtrlHWND,"AnchorValue")
    AnchoredCtrls := Gui(Menu_vGuiHWND(), "_AnchoredCtrls")
    IsAnchored := InStr(AnchoredCtrls,CtrlHWND)
    CheckStatus := IsAnchored ? "+c" : "-c"
    Text := (IsAnchored ? "Change Anchor" : "Anchor Control")
         .  (AnchorValue ? ": " AnchorValue : "")
    MMenu_Set(Menu_ID,5, Text,"", CheckStatus)
  }
  
  Content := Control(CtrlHWND,"Content")
  Text := Content ? "Change Content: " Content : "Set Content"
  MMenu_Set(Menu_ID,6, Text)
}

CommonMenu_ToggleState:
  CommonMenu_ToggleState(Menu_vCtrlHWND(), MMenu_Title)
Return
CommonMenu_ToggleState(CtrlHWND, Prop){
  Control(CtrlHWND,Prop, !Control(CtrlHWND,Prop))
}

CommonMenu_SetVarName:
  CommonMenu_SetVarName(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_SetVarName(GuiHWND, CtrlHWND){
  VarName := Control(CtrlHWND,"_FinalVarName")
  VarName := VarName ? VarName : Control(CtrlHWND,"Label")
  VarName := VarName ? VarName : Gui(GuiHWND,"Label") Control(CtrlHWND,"VarName")
  InputBox, NewVarName, Change Controls VarName, Specify a unique control VarName.`nNothing will remove VarName., , , , Menu_vX(), Menu_vY(), , , %VarName%
  Control(CtrlHWND,"_FinalVarName", NewVarName, NewVarName ? "" : "Clear")
}

CommonMenu_SetLabel:
  CommonMenu_SetLabel(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_SetLabel(GuiHWND, CtrlHWND){
  Label := Control(CtrlHWND,"Label")
  Label := Label ? Label : Control(CtrlHWND,"_FinalVarName")
  Label := Label ? Label : Gui(GuiHWND,"Label") Control(CtrlHWND,"VarName")
  InputBox, NewLabel, Change Controls Label, Specify a unique control label.`nNothing will remove label., , , , Menu_vX(), Menu_vY(), , , %Label%
  Control(CtrlHWND,"Label", NewLabel, NewLabel ? "" : "Clear")
}

CommonMenu_DisableControl:
  CommonMenu_DisableControl(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_DisableControl(GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  Disabled := Control(CtrlHWND,"Disabled")
  GuiControl, %GuiID%:Enable%Disabled%, %CtrlID%
  Control(CtrlHWND,"Disabled", !Disabled)
}

F4:: Assign(Selector_vGuiHWND(),Selector_vCtrlHWND())
Assign(GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  InputBox, Value, Assign Value, Specify Value, , , , Menu_vX(), Menu_vY(), , ,
  StringSplit, Value, Value, %A_Space%, %A_Space%
  GuiControl, %GuiID%:%Value1%, %CtrlID%, %Value2%
}

CommonMenu_Duplicate:
  CommonMenu_Duplicate(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_Duplicate(GuiHWND, CtrlHWND){
  Items2Get = Type|Content
  Loop, Parse, Items2Get, |
    %A_LoopField% := Control(CtrlHWND, A_LoopField)
  ControlGetPos,,, W, H,, ahk_id %CtrlHWND%
  NewCtrlHWND := Control_New(Type, GuiHWND, Content, " X" 1 " Y" 1 " W" W " H" H)

  KeyWait, LButton     ;wait for release of LButton
  WinActivate, ahk_id %GuiHWND%
  CoordMode, Mouse, Relative
  SysGet_GuiFrameSizes(Gui(GuiHWND,"Toolwindow"), XFrame, YFrame, HCaption)
  MouseMove, XFrame + W // 2, HCaption + YFrame + H // 2
  Sleep, 100
  Selector_Size(True)
  Send {LButton down}  ;prepare movement
}

CommonMenu_ChangeContent:
  CommonMenu_ChangeContent(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_ChangeContent(GuiHWND, CtrlHWND){
  Content := Control(CtrlHWND,"Content")
  InputBox, NewContent, Change Controls Content, Specify controls content, , , , Menu_vX(), Menu_vY(), , , %Content%
  If !ErrorLevel  {
    GuiID := Gui(GuiHWND, "GuiID")
    CtrlID := Control(CtrlHWND, "VarName")
    Type := Control(CtrlHWND, "Type")
    If Type in ComboBox,DropDownList,ListBox
      PreFix = |
    Text := Type = "ComboBox" ? "" : "Text"
    GuiControl, %GuiID%:%Text%, %CtrlID%, %PreFix%%NewContent%
    Control(CtrlHWND,"Content", NewContent, NewContent ? "" : "Clear")
  }
}

CommonMenu_AnchorControl:
  CommonMenu_AnchorControl(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_AnchorControl(GuiHWND, ListOfCtrlHWND){
  AnchoredCtrls := Gui(GuiHWND, "_AnchoredCtrls")
  If InStr(ListOfCtrlHWND,"|"){
    AnchorValue = xy
  }Else {
    AnchorValue := Control(ListOfCtrlHWND,"AnchorValue")
    If !AnchorValue
      AnchorValue = xy
  }

  InputBox, NewAnchorValue, Set Anchor for Controls, Specify an anchor expression.`nNothing will remove any anchor, , , , Menu_vX(), Menu_vY(), , , %AnchorValue%
  If NewAnchorValue {
    Loop, Parse, ListOfCtrlHWND, |
      {
        If ("StatusBar" = Control(A_LoopField,"Type"))
          Continue
        Control_Anchor(GuiHWND, A_LoopField, "")
        Control(A_LoopField,"AnchorValue", NewAnchorValue)
        If !InStr(AnchoredCtrls,A_LoopField)
            AnchoredCtrls .= "|" A_LoopField
      }
  }Else{
    AnchoredCtrls = |%AnchoredCtrls%|
    Loop, Parse, ListOfCtrlHWND, |
      {
        CtrlHWND = |%A_LoopField%|
        StringReplace, AnchoredCtrls, AnchoredCtrls, %CtrlHWND%, |
        Control_Anchor(GuiHWND, A_LoopField, "")
      }
  }
  If (InStr(AnchoredCtrls,"|") = 1)
    StringTrimLeft, AnchoredCtrls, AnchoredCtrls, 1
  If (InStr(AnchoredCtrls,"|","",0) = StrLen(AnchoredCtrls))
    StringTrimRight, AnchoredCtrls, AnchoredCtrls, 1
  Gui(GuiHWND, "_AnchoredCtrls", AnchoredCtrls, AnchoredCtrls ? "" : "Clear")
}

CommonMenu_SetLeftRightCenter(GuiHWND, CtrlHWND, NewPosition) {
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControl, %GuiID%:+%NewPosition%, %CtrlID%
  RemoveOptions := RegExReplace("Left,Right,Center,", NewPosition ",")
  StringTrimRight, RemoveOptions, RemoveOptions, 1
  Control_ExchangeProperties(CtrlHWND, "Options", " " NewPosition, RemoveOptions)
}
