; Title:	HLink
;			Custom HyperLink control
;:
; Created by majkinetor

;----------------------------------------------------------------------------------------------
; Function:		Add
;				Creates hyperlink control
;
; Parameters: 	
;				hGui	- Handle of the parent GUI
;				x,y,w,h - Size & position
;				txt		- Text of the control. Links is specified as <a> HTML tag.
;
; Notes:		
;				Controls have ID's internaly. This is used to recgonised control notfications messages
;				ID's for HLink control start from 5701 (the first one you created will have this ID) and
;				are incremented by 1 for each new HLink control you create
;
; Example:
;>     hLink1 := HLink_Add(hGui, "Click <a href=""http://www.Google.com"">here</a> to go to Google", 10, 10, 200, 20)
;
HLink_Add(hGui, x, y, w, h, txt="<a>HLink Control</a>"){
   static ICC_LINK_CLASS=0x8000, WS_CHILD=0x40000000, WS_VISIBLE=0x10000000, WS_TABSTOP=0x10000
   static init=0, id = 5701

   if !init++ 
      API_InitCommonControlsEx(ICC_LINK_CLASS)

   id++
   hWnd := DllCall("CreateWindowEx"
                  ,"Uint", 0
                  ,"str",  "SysLink"
                  ,"str",  txt
                  ,"Uint", WS_CHILD | WS_VISIBLE | WS_TABSTOP
                  ,"int",  x, "int", y, "int", w, "int", h
                  ,"Uint", hGui
                  ,"Uint", id
                  ,"Uint", 0
                  ,"Uint", 0)
   return hWnd
}

;-------------------------------------------------------------------------------------------------------------

HLink_About(v=""){
	static ver=0.9
	
	if (v="ver")
		return ver
	else {
	   msg := "HLink  " ver "`n"
	   msg .= "Created by majkinetor`n`n"
	   msg .= "See http://www.autohotkey.com/forum/viewtopic.php?p=124071#124071"
	}
	return msg
}


API_InitCommonControlsEx( flags ){
   VarSetCapacity(S, 8), NumPut(8, S, 0), NumPut(flags, S, 4) 
   return DllCall("comctl32.dll\InitCommonControlsEx", "uint", &S)
}
